import java.util.*;
import java.applet.*;
import java.awt.*;

public class GroupsDlg extends Dialog  {

    protected TextField   groupName = new TextField( 15 );
    protected List        groupList = new List( 2, false );
     
    protected Applet      app;
    protected GroupList   groups;
              boolean     delete = false;

    Button addButton = new Button( "Add" );
    Button deleteButton = new Button( "Delete" );
    Button doneButton = new Button( "Done" );

    Panel section2          = new Panel();
    public static final String title = "Manage Groups";


    public GroupsDlg( Applet tapp, Frame parent, GroupList tGroups )  {
        super( parent, title, true );

         // init
         app = tapp;
         groups = tGroups;

         //Groups Dialog

        GridBagConstraints gbc;
        GridBagLayout gb;

        gb = new GridBagLayout();
        setLayout( gb );
        Panel quad1 = new Panel();
        Panel quad2 = new Panel();
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.7;
        gbc.weighty = 1.0;
        gbc.gridwidth = GridBagConstraints.RELATIVE;
        gb.setConstraints( quad1, gbc );
        add( quad1 );
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.3;
        gbc.weighty = 1.0;
        gb.setConstraints( quad2, gbc );
        add( quad2 );

        // divide quad1 into 2 segments
        quad1.setLayout( new GridLayout( 2, 1, 5, 0 ));
        Panel newGroup          = new Panel();
        Panel deleteGroup       = new Panel();
        quad1.add( newGroup );
        quad1.add( deleteGroup );

        // divide quad2 into 3 segments
        quad2.setLayout( new GridLayout( 3, 1, 5, 0 ));
        quad2.add( addButton );
        quad2.add( deleteButton );
        quad2.add( doneButton );

        newGroup.setLayout( new GridLayout( 1, 2, 5, 5 ));
        Panel label1            = new Panel();
        Panel section1          = new Panel();
        newGroup.add( label1 );
        newGroup.add( section1 );

        label1.setLayout( new FlowLayout( FlowLayout.RIGHT, 0, 0 ));
        label1.add( new Label( "New Group:" ));

        section1.setLayout( new FlowLayout( FlowLayout.LEFT, 0, 0 ));
        section1.add( groupName );

        deleteGroup.setLayout( new GridLayout( 1, 2, 5, 5 ));
        Panel label2            = new Panel();
        deleteGroup.add( label2 );
        deleteGroup.add( section2 );

        label2.setLayout( new GridLayout( 2, 1, 0, 0 ));
        Panel label2_2          = new Panel();
        label2.add( label2_2 );
        label2_2.setLayout( new FlowLayout( FlowLayout.RIGHT, 0, 0 ));
        label2_2.add( new Label( "Delete Group:" ));

        section2.setLayout( new FlowLayout( FlowLayout.LEFT, 0, 0 ));
        section2.add( groupList );

        int i, max;
        max = groups.getNumGroups();
        for ( i = 0; i < max; i++ ) {
            groupList.addItem( groups.getGroup( i ));
        }

        this.resize( 350, 140 );
        this.show();
    }
    
    // Button event handler 
    public boolean handleEvent( Event evt )  {
        String strName = null;
        Frame  mFrame  = null;
        Dialog mDialog = null;
        int i, max;
 
        // pass-through event handlers
        if ( evt.target == groupName )  {
        }
        else if ( evt.target == groupList ) {
        }

        // add button
        else if (( evt.target == addButton ) &&
                 ( evt.id == Event.ACTION_EVENT )) {
            strName = groupName.getText();
            if ( strName.length() > 14 ) {
                strName = strName.substring( 0, 14 );
            }
            if ( strName.compareTo( "" ) != 0 ) {
                if ( groups.addGroup( strName ) == false ) {
                    //Message dialog stating group exist.
                    mFrame = ToDo.getFrame(this);
                    mDialog = new MsgDlg( app, mFrame, 
                        "That group already exists", "" );
                }
                else {
                    groupName.setText( "" );
                    groupList.clear();
                    max = groups.getNumGroups();
                    for ( i = 0; i < max; i++ ) {
                        groupList.addItem( groups.getGroup( i ));
                        if ( strName.compareTo( groups.getGroup( i )) == 0 ) {
                            groupList.makeVisible( i );
                        }
                    }
                }
            }
            else {
                mFrame = ToDo.getFrame(this);
                mDialog = new MsgDlg( app, mFrame, "No group to add", "" );
            }
        }

        // delete button
        else if (( evt.target == deleteButton ) && 
                 ( evt.id == Event.ACTION_EVENT )) {
            strName = groupList.getSelectedItem();
            if (( strName != null ) &&
                    ( strName.compareTo( GroupList.BLANK ) != 0 ))  {
                mFrame = ToDo.getFrame(this);
                mDialog = new YesNoDlg( this, mFrame, 
                    "This will delete all items in this group.",
                    "Continue?" );
            }
            else {
                mFrame = ToDo.getFrame(this);
                mDialog = new MsgDlg(app, mFrame, "No Group to Delete", "" );
            }
        }

        // done button
        else if (evt.target == doneButton)  {
            this.hide();
            Event groupEvent = new Event( this, 0, new Boolean(delete) );
            app.handleEvent( groupEvent );
        }

        // YesNoDlg return
        else if ( evt.target instanceof YesNoDlg ) {
            if ( ((Boolean)evt.arg).booleanValue() == true ) {
                strName = groupList.getSelectedItem();
                groups.deleteGroup( strName );
                delete = true;
                groupList.delItem( groupList.getSelectedIndex() );
            }
        }

        // default
        else  {
            return true;
        }
        return false;
    }
}

