import java.util.*;
import java.applet.*;
import java.awt.*;

public class LoginDlg extends Dialog  {

    protected TextField   userName = new TextField( 15 );
    protected TextField   password = new TextField( 15 );
    protected Choice      groupList = new Choice();
     
    protected Applet      app;
    protected Frame       parent;
    protected RemoteFile  file;

    Button loginButton = new Button( "Login" );
    Button cancelButton = new Button( "Cancel" );

    public static final String title = "To-Do List Manager Login";


    public LoginDlg( Applet tapp, Frame tparent, RemoteFile tfile )  {
        super( tparent, title, true );

        GridBagConstraints gbc;
        GridBagLayout gb;

        // init
        app = tapp;
        file = tfile;
        parent = tparent;

        password.setEchoCharacter('*');

        gb = new GridBagLayout();
        this.setLayout( gb );
        Panel quad1 = new Panel();
        Panel quad2 = new Panel();
        Panel quad3 = new Panel();
        Panel quad4 = new Panel();
        Panel msgArea = new Panel();

        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.9;
        gbc.weighty = 0.5;
        gb.setConstraints( quad1, gbc );
        add( quad1 );

        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.1;
        gbc.weighty = 0.5;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gb.setConstraints( quad2, gbc );
        add( quad2 );

        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.9;
        gbc.weighty = 0.4;
        gb.setConstraints( quad3, gbc );
        add( quad3 );

        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.1;
        gbc.weighty = 0.4;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gb.setConstraints( quad4, gbc );
        add( quad4 );

        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 1.0;
        gbc.weighty = 0.2;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gb.setConstraints( msgArea, gbc );
        add( msgArea );

        quad1.setLayout( new GridLayout( 1, 2, 5, 5 ));
        Panel label1 = new Panel();
        Panel nameArea = new Panel();
        quad1.add( label1 );
        quad1.add( nameArea );

        label1.setLayout( new FlowLayout( FlowLayout.RIGHT ));
        label1.add( new Label( "User Name:" ));
        nameArea.setLayout( new FlowLayout( FlowLayout.LEFT ));
        nameArea.add( userName );

        quad2.setLayout( new GridLayout( 1, 1, 5, 5 ));
        quad2.add( loginButton );

        quad3.setLayout( new GridLayout( 1, 2, 5, 5 ));
        Panel label2 = new Panel();
        Panel passArea = new Panel();
        quad3.add( label2 );
        quad3.add( passArea );

        label2.setLayout( new FlowLayout( FlowLayout.RIGHT ));
        label2.add( new Label( "Password:" ));
        passArea.setLayout( new FlowLayout( FlowLayout.LEFT ));
        passArea.add( password );

        quad4.setLayout( new GridLayout( 1, 1, 5, 5 ));
        quad4.add( cancelButton );

        msgArea.setLayout( new FlowLayout( FlowLayout.CENTER ));
        msgArea.add( new Label( "Login may take up to 1 minute" ));

        this.resize( 375, 175 );
        this.show();
    }
    
    // Button event handler 
    public boolean handleEvent(Event evt)  {
        boolean cancel = false;
        boolean success = false;
        String newUserName, newPassword;

        // pass-thrus for text fields
        if ( evt.target == userName ) {
        }
        else if ( evt.target == password ) {
        }
        else if (( evt.target == loginButton ) &&
                ( evt.id == Event.ACTION_EVENT )) {
            newUserName = userName.getText();
            newPassword = password.getText();
            success = file.login( newUserName, newPassword );
            if ( success == false ) {
                password.setText("");
                new MsgDlg( app, parent, "Login failed", "" );
            }
            else {
                this.hide();
                Event loginEvent = new Event( this, 0, new Boolean(cancel) );
                app.handleEvent( loginEvent );
            }
        }
        else if (( evt.target == cancelButton ) &&
                ( evt.id == Event.ACTION_EVENT )) {
            cancel = true;
            this.hide();
            Event loginEvent = new Event( this, 0, new Boolean(cancel) );
            app.handleEvent( loginEvent );
        }

        else  {
            return true;
        }

        return false;
    }
}

