import java.util.*;
import java.applet.*;
import java.awt.*;

public class NewDlg extends Dialog  {

    protected TextField   description = new TextField( 40 );
    protected TextField   dueMonth = new TextField( 2 );
    protected TextField   dueDate = new TextField( 2 );
    protected TextField   dueYear = new TextField( 4 );
    protected TextField   startMonth = new TextField( 2 );
    protected TextField   startDate = new TextField( 2 );
    protected TextField   startYear = new TextField( 4 );
    protected Choice      priority = new Choice();
    protected List        groupList = new List( 2, false );
    protected Item        newItem = new Item();

    protected Applet      app;
    protected GroupList   groups;

    Button addButton = new Button( "Add" );
    Button cancelButton = new Button( "Cancel" );

    public static final String title = "New Item";


    public NewDlg( Applet tapp, Frame parent, GroupList tGroups )  {
        super( parent, title, true );

         // init
         app = tapp;
         groups = tGroups;

        // Initialize w/ data

        priority.addItem( "Boiling" );
        priority.addItem( "Hot" );
        priority.addItem( "Warm" );
        priority.addItem( "Cold" );
        priority.addItem( "Iced" );
        priority.select( "Warm" );
   
        Date currentDate = new Date();
        startMonth.setText( Integer.toString(currentDate.getMonth() + 1 ) );
        startDate.setText( Integer.toString(currentDate.getDate()) );
        startYear.setText( Integer.toString(currentDate.getYear() + 1900 ) );


         //Draw Screen

        GridBagConstraints gbc;
        GridBagLayout gb;

        gb = new GridBagLayout();
        setLayout( gb );
        Panel quad1 = new Panel();
        Panel quad2 = new Panel();
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.8;
        gbc.weighty = 0.5;
        gb.setConstraints( quad1, gbc );
        add( quad1 );
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.2;
        gbc.weighty = 0.5;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gb.setConstraints( quad2, gbc );
        add( quad2 );
 
        // divide quad 3 into 8 areas
        //   label1         - "Description:"
        //   descArea       - text area for description
        //   label2         - "Due Date:"
        //   duePriArea     - due date, priority label and priority drop-down
        //   label3         - "Start Date:"
        //   startGroupArea - start date, group label and group drop-down
        //   saveArea       - Save Button
        //   nullArea       - nothing goes in this area
        gb = new GridBagLayout();
        quad1.setLayout( gb );
        Panel label1         = new Panel();
        Panel descArea       = new Panel();
        Panel label2         = new Panel();
        Panel duePriArea     = new Panel();
        Panel label3         = new Panel();
        Panel startGroupArea = new Panel();
        Panel saveArea       = new Panel();
        Panel nullArea       = new Panel();
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.11;
        gbc.weighty = 0.25;
        gb.setConstraints( label1, gbc );
        quad1.add( label1 );
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.89;
        gbc.weighty = 0.25;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gb.setConstraints( descArea, gbc );
        quad1.add( descArea );
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.11;
        gbc.weighty = 0.25;
        gb.setConstraints( label2, gbc );
        quad1.add( label2 );
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.89;
        gbc.weighty = 0.25;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gb.setConstraints( duePriArea, gbc );
        quad1.add( duePriArea );
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.11;
        gbc.weighty = 0.25;
        gb.setConstraints( label3, gbc );
        quad1.add( label3 );
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.89;
        gbc.weighty = 0.25;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gb.setConstraints( startGroupArea, gbc );
        quad1.add( startGroupArea );
        gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 0.11;
        gbc.weighty = 0.25;
        gb.setConstraints( saveArea, gbc );
        quad1.add( saveArea );
        gbc = new GridBagConstraints();
        gbc.weightx = 0.89;
        gbc.weighty = 0.25;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gb.setConstraints( nullArea, gbc );
        quad1.add( nullArea );
 
        // add spacing on labels, saveArea and descArea
        label1.setLayout( new FlowLayout( FlowLayout.RIGHT, 5, 5 ));
        label2.setLayout( new FlowLayout( FlowLayout.RIGHT, 5, 5 ));
        label3.setLayout( new FlowLayout( FlowLayout.RIGHT, 5, 5 ));
        saveArea.setLayout( new GridLayout( 1, 1, 5, 5 ));
        descArea.setLayout( new FlowLayout( FlowLayout.LEFT, 5, 5 ));
 
        // set layout and spacing on duePriArea
        duePriArea.setLayout( new FlowLayout( FlowLayout.LEFT ));
        Panel dueArea      = new Panel();
        Panel priorityArea = new Panel();
        duePriArea.add( dueArea );
        duePriArea.add( priorityArea );
 
        // set spacing on dueArea
        dueArea.setLayout( new FlowLayout( FlowLayout.LEFT, 5, 0 ));
 
        // set spacing on priorityArea
        priorityArea.setLayout( new GridLayout( 1, 1, 5, 0 ));
        Panel label4         = new Panel();
        Panel label5         = new Panel();
        label4.setLayout( new FlowLayout( FlowLayout.RIGHT, 5, 5 ));
        label5.setLayout( new FlowLayout( FlowLayout.RIGHT, 5, 5 ));
 
        // set layout and spacing on startGroupArea
        startGroupArea.setLayout( new FlowLayout( FlowLayout.LEFT ));
        Panel startArea = new Panel();
        Panel groupArea = new Panel();
        startGroupArea.add( startArea );
        startGroupArea.add( groupArea );
 
        // set spacing on startArea
        startArea.setLayout( new FlowLayout( FlowLayout.LEFT, 5, 0 ));
 
        // set spacing on groupArea
        groupArea.setLayout( new FlowLayout( FlowLayout.LEFT, 5, 0 ));
 
 
        // Add description line
        label1.add( new Label( "Description:" ));
        descArea.add( description );
 
        // Add due date stuff
        label2.add( new Label( "Due Date:" ));
        dueArea.add( dueMonth );
        dueArea.add( new Label( "/" ));
        dueArea.add( dueDate );
        dueArea.add( new Label( "/" ));
        dueArea.add( dueYear );
 
        // add priority stuff
        priorityArea.add( label4 );
        priorityArea.add( priority );
        label4.add( new Label( "Priority:" ));
 
        // add start date stuff
        label3.add( new Label( "Start Date:" ));
        startArea.add( startMonth );
        startArea.add( new Label( "/" ));
        startArea.add( startDate );
        startArea.add( new Label( "/" ));
        startArea.add( startYear );
 
        // add group stuff
        groupArea.add( label5 );
        groupArea.add( groupList );
        label5.add( new Label( "Group:" ));
 
        // divide quad2 into 4 segments
        quad2.setLayout( new GridLayout( 4, 1, 5, 5 ));
 
        Panel adds              = new Panel();
        Panel cancels           = new Panel();
        Panel null1             = new Panel();
        Panel null2             = new Panel();

        // add layout for buttons
        quad2.add( adds );
        quad2.add( cancels );
        quad2.add( null1 );
        quad2.add( null2 );

        adds.setLayout(new GridLayout( 1, 1, 0, 0 ));
        adds.add(addButton);

        cancels.setLayout(new GridLayout( 1, 1, 0, 0 ));
        cancels.add(cancelButton);
 
        int i, max;
        max = groups.getNumGroups();
        for ( i = 0; i < max; i++ ) {
            groupList.addItem( groups.getGroup( i ));
        }
 
        this.resize( 600, 200 );
        this.show();
 


    }
    
    // Button event handler 
    public boolean handleEvent( Event evt )  {
        String strName = null;
        Frame  tFrame  = null;
        int newDueMonth, newDueDate, newDueYear;
        int newStartMonth, newStartDate, newStartYear;
 
        // pass-through event handlers
        if ( evt.target == description )  {
        }
        else if ( evt.target == dueMonth ) {
        }
        else if ( evt.target == dueDate ) {
        }
        else if ( evt.target == dueYear ) {
        }
        else if ( evt.target == startMonth ) {
        }
        else if ( evt.target == startDate ) {
        }
        else if ( evt.target == startYear ) {
        }
        else if ( evt.target == groupList ) {
        }


        // add button
        else if (( evt.target == addButton ) &&
                 ( evt.id == Event.ACTION_EVENT )) {

            Item newItem = new Item();
            boolean noDueDate = false;

            strName = dueMonth.getText();
            if ( strName.compareTo( "" ) == 0 ) {
                strName = dueDate.getText();
                if ( strName.compareTo( "" ) == 0 ) {
                    strName = dueYear.getText();
                    if ( strName.compareTo( "" ) == 0 ) {
                        noDueDate = true;
                    }
                }
            }

            if ( noDueDate == false ) {
                strName = dueMonth.getText();
                if ( strName.compareTo( "" ) == 0 ) {
                    error( "Due Date (Month)" );
                    return true;
                }
                strName = dueDate.getText();
                if ( strName.compareTo( "" ) == 0 ) {
                    error( "Due Date (Day)" );
                    return true;
                }
                strName = dueYear.getText();
                if ( strName.compareTo( "" ) == 0 ) {
                    error( "Due Date (Year)" );
                    return true;
                }
            }
            strName = description.getText();
            if ( strName.compareTo( "" ) == 0 ) {
                error( "Description" );
                return true;
            }
            strName = startMonth.getText();
            if ( strName.compareTo( "" ) == 0 ) {
                error( "Start Date(Month)" );
                return true;
            }
            strName = startDate.getText();
            if ( strName.compareTo( "" ) == 0 ) {
                error( "Start Date(Day)" );
                return true;
            }
            strName = startYear.getText();
            if ( strName.compareTo( "" ) == 0 ) {
                error( "Start Date(Year)" );
                return true;
            }

            try {
                if ( noDueDate == false ) {
                    newDueMonth = Integer.parseInt( dueMonth.getText() );
                    newDueDate = Integer.parseInt( dueDate.getText() );
                    newDueYear = Integer.parseInt( dueYear.getText() );
                }
                else {
                    newDueMonth = Integer.parseInt( startMonth.getText() );
                    newDueDate = Integer.parseInt( startDate.getText() );
                    newDueYear = Integer.parseInt( startYear.getText() );
                }
                newStartMonth = Integer.parseInt( startMonth.getText() );
                newStartDate = Integer.parseInt( startDate.getText() );
                newStartYear = Integer.parseInt( startYear.getText() );
            }
            catch ( NumberFormatException e ) {
                badDate( "Date fields must contain integers." );
                return true;
            }

            if (( newDueYear < 1900 ) || ( newStartYear < 1900 )) {
                badDate( "Year must be greater than 1900." );
                return true;
            }
            if (( newDueYear > 2037 ) || ( newStartYear > 2037 )) {
                badDate( "Year must be less than 2037." );
                return true;
            }
            if (( newDueMonth < 1 ) || ( newDueMonth > 12 ) ||
                ( newStartMonth < 1 ) || ( newStartMonth > 12 )) {
                badDate( "Month must be between 1 and 12." );
                return true;
            }
            if (( newDueMonth == 2 ) &&
                (((( newDueYear % 4 ) == 0 ) && ( newDueDate > 29 )) ||
                ((( newDueYear % 4 ) != 0 ) && ( newDueDate > 28 )))) {
                badDate( "Specified day does not exist in this month." );
                return true;
            }
            if (( newStartMonth == 2 ) &&
                (((( newStartYear % 4 ) == 0 ) && ( newStartDate > 29 )) ||
                ((( newStartYear % 4 ) != 0 ) && ( newStartDate > 28 )))) {
                badDate( "Specified day does not exist in this month." );
                return true;
            }
            if (( newDueDate < 1 ) || ( newStartDate < 1 )) {
                badDate( "Specified day does not exist in this month." );
                return true;
            }
            if ((( newDueMonth == 1 ) || ( newDueMonth == 3 ) ||
                ( newDueMonth == 5 ) || ( newDueMonth == 7 ) ||
                ( newDueMonth == 8 ) || ( newDueMonth == 10 ) ||
                ( newDueMonth == 12 )) && ( newDueDate > 31 )) {
                badDate( "Specified day does not exist in this month." );
                return true;
            }
            if ((( newDueMonth == 4 ) || ( newDueMonth == 6 ) ||
                ( newDueMonth == 9 ) || ( newDueMonth == 11 )) &&
                ( newDueDate > 30 )) {
                badDate( "Specified day does not exist in this month." );
                return true;
            }
            if ((( newStartMonth == 1 ) || ( newStartMonth == 3 ) ||
                ( newStartMonth == 5 ) || ( newStartMonth == 7 ) ||
                ( newStartMonth == 8 ) || ( newStartMonth == 10 ) ||
                ( newStartMonth == 12 )) && ( newStartDate > 31 )) {
                badDate( "Specified day does not exist in this month." );
                return true;
            }
            if ((( newStartMonth == 4 ) || ( newStartMonth == 6 ) ||
                ( newStartMonth == 9 ) || ( newStartMonth == 11 )) &&
                ( newStartDate > 30 )) {
                badDate( "Specified day does not exist in this month." );
                return true;
            }

            if ( newDueYear < newStartYear ) {
                badDate( "Due date is prior to start date." );
                return true;
            }
            else if (( newDueYear == newStartYear ) &&
                ( newDueMonth < newStartMonth )) {
                badDate( "Due date is prior to start date." );
                return true;
            }
            else if (( newDueYear == newStartYear ) &&
                ( newDueMonth == newStartMonth ) &&
                ( newDueDate < newStartDate )) {
                badDate( "Due date is prior to start date." );
                return true;
            }
            
            newItem.description = description.getText();
            newItem.startDate = new Date( newStartYear - 1900,
                    newStartMonth - 1, newStartDate, 0, 0, 0 );
            if ( noDueDate == true ) {
                newItem.endDate = newItem.startDate;
            }
            else {
                newItem.endDate = new Date( newDueYear - 1900,
                    newDueMonth - 1, newDueDate, 0, 0, 0 );
            }
            newItem.group = groupList.getSelectedItem();
            if ( newItem.group == null ) {
                newItem.group = GroupList.BLANK;
            }
            newItem.priority = priority.getSelectedIndex() + 1;

            this.hide();
            Event newEvent = new Event( this, 0, newItem );
            app.handleEvent( newEvent );
        }

        // cancel button
        else if (evt.target == cancelButton)  {
            this.hide();
        }

        // default
        else  {
            return true;
        }
        return false;
    }

    // Message dialog stating empty field.
    protected void error( String field ) {
        Frame tFrame;

        tFrame = ToDo.getFrame( this );
        new MsgDlg( app, tFrame, field + " field is empty.", 
            "Please fill all text fields" );
    }

    // Message dialog stating bad date
    protected void badDate( String msg ) {
        Frame tFrame;

        tFrame = ToDo.getFrame( this );
        new MsgDlg( app, tFrame, "Invalid date.",  msg );
    }

}
